#include "distmaps.h"

/* #define MM_DEBUG */

/*
     --------------------------------------------------------
     FUNCTION: fz_edt_meijster - Euclidean Distance transform
     --------------------------------------------------------
*/
                 /*+ Purpose: giving a binary image determine its
                              Euclidean distance transform. Works for 1D, 2D,
			      cases                                        +*/
int fz_edt_meijster(int *pf, int *pg, int size[2])
{
/*  author: Roberto Lotufo                                                  */
/*  Date:Fri May 04 08:58:05 EDT 2001                                       */

  int w,h,d, i, j, k, b, q, np;
  unsigned int inf;
  int *pfj;
  int *pgj, *pgi, *paux;
  int *s, *t;

  w=size[0]; h=size[1]; d=1;
  s = (int *)malloc((w+h+d) * sizeof(int));
  t = (int *)malloc((w+h+d) * sizeof(int));

  paux = (int *)malloc(w *sizeof(int));

  np = w*h*d;
  inf = np + 1;
  for (i=0; i<np; i++) pg[i]=inf;

  for(j=0;j<w;j++) { /* para cada coluna j */
    pfj=&pf[j];
    pgj=&pg[j];
    i=0;
    while (pfj[i*w]) { /* espera chegar o primeiro pixel 0 */
      i++;
      if (i>=h) break;
    }
    if (i<=(h-1)) { /* se chegou pela primeira vez */
      k=i; pgj[k*w]=0;
      b=1; k--;
      while (k >= 0) { /* volta subindo ate inicio da linha */
	pgj[k*w] = pgj[(k+1)*w] + b;
	b=b+2;k--;
      }
      i++;
      while (i<=(h-1)) { /* Loop principal deste primeiro passo */
	while (pfj[i*w] == 0) { /* enquanto for 0, g=0 */
	  pgj[i*w]=0; i++;
	  if (i >= h) break;
	}
	if (i<=(h-1)) {
	  b=1;
	  while (pfj[i*w]) { /* enquanto for 1, sobe */
	    pgj[i*w] = pgj[(i-1)*w] + b;
	    b = b + 2; i++;
	    if (i >= h) break;
	  }
	  if (i<=(h-1)) { 
	    k=i; pgj[k*w]=0; b=1;
	    while (pgj[(k-1)*w] > pgj[k*w]) { /* volta subindo */
	      pgj[(k-1)*w] = pgj[k*w] + b;
	      b = b + 2; k--;
	    }
	    i++;
	  }
	}
      }
    }
  }

#ifdef MM_DEBUG
  printf("mm_edt_meijster: end of erosion by line\n");
#endif
  /* segunda parte, erosao por propagacao, linha por linha */
#define BB(i,h,u) (((i)-(h))*((i)+(h)-2*(u)) < pgi[h]-pgi[i])
#define SEP(i,h)  ((((h)+(i))*((h)-(i))+pgi[h]-pgi[i])/(2*((h)-(i))))
  for (i=0; i<h; i++) {
#ifdef MM_DEBUG
    printf("mm_edt_meijster: for each line %d\n",i);
#endif
    /* Scan3 */
    pgi = &pg[i*w];
    q = 0;
    s[0] = t[0] = 0;
    for (j=1; j<w; j++) {
#ifdef MM_DEBUG
      printf("u=%d  s[q]=%d t[q]=%d\n",j+1, s[q]+1, t[q]+1);
#endif
      while (q >= 0 && BB(j,s[q],t[q])) {
          q--;
#ifdef MM_DEBUG
	  printf("varre q=%d\n",q+1);
#endif
      }
      if (q < 0) {
        q = 0 ;
        s [0] = j ;
#ifdef MM_DEBUG
	printf("%d eh o pivo da primeira regiao\n",j+1);
#endif
      } else {
        int ww = 1 + SEP(s[q], j) ;
        if (ww < w) {
          q ++ ;
          s[q] = j ;
	  t[q] = ww ; 
#ifdef MM_DEBUG
	  printf("Nova regiao pivo=%d inicio=%d\n",j+1,w+1);
#endif
        }
      }
    }
    /* Scan4 */
    memcpy(paux, pgi, w*sizeof(int));
    for (j=w-1; j>=0; j--) {
      pgi[j] = (j-s[q])*(j-s[q]) + paux[s[q]] ;
#ifdef MM_DEBUG
      printf("pgi[%d]=%d t[%d]=%d s[%d]=%d\n",j,pgi[j],q,t[q],q,s[q]);
#endif
      if (j == t[q]) q -- ;
    }
  }
#ifdef MM_DEBUG
  printf("mm_edt_meijster: end of second phase\n");
#endif
  free(paux);
  free(s);
  free(t);

  return 1;
}
